using System;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace CSSamples.Samples
{
    public partial class DisplayASimpleMap : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
               Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
               Map1.CurrentExtent = new RectangleShape(-131.22, 55.05, -54.03, 16.91);
               Map1.MapUnit = GeographyUnit.DecimalDegree;

               ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(MapPath("~/SampleData/world/cntry02.shp"));
               worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(255, 243, 239, 228), GeoColor.FromArgb(255, 218, 193, 163), 1);
               worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

               LayerOverlay layerOverlay = new LayerOverlay();
               layerOverlay.Layers.Add(worldLayer);
               Map1.CustomOverlays.Add(layerOverlay);

               SimpleMarkerOverlay simpleMarkers = new SimpleMarkerOverlay("SimpleMarkers");
               Map1.CustomOverlays.Add(simpleMarkers);
            }
        }

        protected void Button1_Click(object sender, EventArgs args) {
           Marker marker = new Marker(-95.28109, 38.95363, new WebImage(21, 25, -10.5f, -25f));
           SimpleMarkerOverlay simpleMarkers = (SimpleMarkerOverlay)Map1.CustomOverlays["SimpleMarkers"];
           simpleMarkers.Markers.Add(marker);

           ContextMenu ctx = new ContextMenu("area", 180);
           ContextMenuItem showPositionItem = new ContextMenuItem("CurrentPosition(Server Event)");
           showPositionItem.Click += new EventHandler<ContextMenuItemClickEventArgs>(showPositionItem_Click);

           ctx.MenuItems.Add(showPositionItem);
           marker.ContextMenu = ctx;
        }

        protected void Button2_Click(object sender, EventArgs args) {
           Marker marker = new Marker(-100, 50, new WebImage(21, 25, -10.5f, -25f));
           SimpleMarkerOverlay simpleMarkers = (SimpleMarkerOverlay)Map1.CustomOverlays["SimpleMarkers"];
           simpleMarkers.Markers.Add(marker);

           ContextMenu ctx = new ContextMenu("area2", 180);
           ContextMenuItem showPositionItem = new ContextMenuItem("CurrentPosition(Server Event)");
           showPositionItem.Click += new EventHandler<ContextMenuItemClickEventArgs>(showPositionItem_Click);

           ctx.MenuItems.Add(showPositionItem);
           marker.ContextMenu = ctx;
        }

        void showPositionItem_Click(object sender, ContextMenuItemClickEventArgs e) {
           divPosition.InnerHtml = string.Format("Current Position: X:{0}, Y:{1}", e.Location.X, e.Location.Y);
        }
    }
}
